#!/usr/bin/perl

# ARCADEmini converter: bmm2amasm
# version 1.0 date 2003-11-02
# part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
# written by 1stein <1stein@schuermans.info>
# based on blinkenplayer.pl by stray <stray@stray.ch>
# Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html

print <<EOF;
ARCADEmini converter: bmm2amasm
version 1.0 date 2003-11-02
part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
written by 1stein <1stein\@schuermans.info>
based on blinkenplayer.pl by stray <stray\@stray.ch>
Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html

EOF

if( @ARGV < 1 )
{
	print <<EOF;
syntax: bmm2amasm <bmm-file> [<amasm-file>]

examples: bmm2amasm example.bmm
          bmm2amasm example.bmm example.amasm

EOF
	exit;
}

read_source( $ARGV[0] );

if( @ARGV < 2 ) { $file = $ARGV[0] . ".amasm"; } else { $file = $ARGV[1]; }
open( F, "> " . $file ) || die "Can't open output file \"$file\": $!\n";

$char[0] = " ";
$char[1] = " ";
$char[2] = " ";
$char[3] = " ";
$char[4] = "+";
$char[5] = "+";
$char[6] = "+";
$char[7] = "+";
$char[8] = "*";
$char[9] = "*";
$char[10] = "*";
$char[11] = "*";
$char[12] = "#";
$char[13] = "#";
$char[14] = "#";
$char[15] = "#";

for( $f = 0; $f <= $#del; $f++) {

	$chars = @{@{$frames[$f]}[0]};
	if( $chars > 26 ) { $chars = 26 };
	$lines = @{$frames[$f]};
	if( $lines > 20 ) { $lines = 20 };
	$left = (26 - $chars) / 2;
	$right = 26 - $chars - $left;
	$top = (20 - $lines) / 2;
	$bottom = 20 - $lines - $top;

	$nibble = 0;
	for( $i = 0; $i < 26 * $top; $i++, $nibble++ ) { @nibbles[$nibble] = 0; }
	$linenum = 0;
	foreach (@{$frames[$f]}) {
	  if( $linenum < 26 ) { for( $i = 0; $i < $left; $i++, $nibble++ ) { @nibbles[$nibble] = 0; } }
	  $charnum = 0;
	  foreach (@$_) {
		print($char[$_ / 0x10]);
		if( $linenum < 20 && $charnum < 26 ) {
		  @nibbles[$nibble] = $_ / 0x10;
		  $nibble++;
		}
		$charnum++;
	  }
	  if( $linenum < 26 ) { for( $i = 0; $i < $right; $i++, $nibble++ ) { @nibbles[$nibble] = 0; } }
	  print("\n");
	  $linenum++;
	}
	for( $i = 0; $i < 26 * $bottom; $i++, $nibble++ ) { @nibbles[$nibble] = 0; }

	print F "                WR_PIX_QUART    0,\n                                ";
	for( $byte = 0; $byte < 65; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 0x10 + @nibbles[$byte*2+$nibble];
		}
                if( $byte % 8 == 7 ) { print F $val . ",\n                                "; }
                else { if( $byte == 64 ) { print F $val . ";\n"; } else { print F $val . ", "; } }
	}

	print F "                WR_PIX_QUART    1,\n                                ";
	for( $byte = 65; $byte < 130; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 16 + @nibbles[$byte*2+$nibble];
		}
                if( ($byte - 65) % 8 == 7 ) { print F $val . ",\n                                "; }
                else { if( $byte == 129 ) { print F $val . ";\n"; } else { print F $val . ", "; } }
	}

	print F "                WR_PIX_QUART    2,\n                                ";
	for( $byte = 130; $byte < 195; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 16 + @nibbles[$byte*2+$nibble];
		}
                if( ($byte - 130) % 8 == 7 ) { print F $val . ",\n                                "; }
                else { if( $byte == 194 ) { print F $val . ";\n"; } else { print F $val . ", "; } }
	}

	print F "                WR_PIX_QUART    3,\n                                ";
	for( $byte = 195; $byte < 260; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 16 + @nibbles[$byte*2+$nibble];
		}
                if( ($byte - 195) % 8 == 7 ) { print F $val . ",\n                                "; }
                else { if( $byte == 259 ) { print F $val . ";\n"; } else { print F $val . ", "; } }
	}

        print F "                DISPLAY;\n";

        print F "                DELAY_DO        " . $del[$f] . ";\n";
}

close F;

sub read_source {
  my $file = shift;
  open (F, $file) || die "Can't open input file \"$file\": $!\n";
  foreach $line (<F>) {
	chomp $line; chomp $line;
	$line =~ s/#.*//;
	next unless $line =~ /\S+/;
	if ($line =~ /^\@(\d+)/) {
	  push(@del,$1);
	  $frame = $#del;
	  next;
	}
	push(@{$frames[$frame]}, [split(/ +/,$line)]); 
  }
  close F;
}

